package jmsweb2;

import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicSession;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class Publisher {

	static int random_num = ( int ) ( Math.random() * 100 );
	static String login = "User_" + random_num;
	
	public void send(String msg) {
		
		System.setProperty("java.naming.factory.initial","fr.dyade.aaa.jndi2.client.NamingContextFactory");
        System.setProperty("javax.naming.factory.host","localhost");
        System.setProperty("javax.naming.factory.port","16400");
        
        InitialContext initCtx;
        
		try {
			
			initCtx = new InitialContext();
			TopicConnectionFactory topicCF = (TopicConnectionFactory) initCtx.lookup("TopicConnectionFactory");
			
	        Topic topic = (Topic) initCtx.lookup("MyTopic");
			
			initCtx.close();
			
			TopicConnection topicConnection = topicCF.createTopicConnection();
			
			TopicSession topicSession = topicConnection.createTopicSession(false,TopicSession.AUTO_ACKNOWLEDGE);
			
			 MessageProducer pub = topicSession.createProducer(topic);
			 
			 TextMessage message = topicSession.createTextMessage();
			 
			 message.setText(msg);
			 
			 message.setStringProperty("login", login);
			 
			 pub.send(message);
			 
			 topicConnection.close();
			 
		} catch (NamingException e) {
			e.printStackTrace();
		} catch (JMSException e) {
			e.printStackTrace();
		}
        
     		
	}

}

