package jmsweb2;

import javax.jms.TopicConnectionFactory;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.objectweb.joram.client.jms.admin.AdminModule;
import org.objectweb.joram.client.jms.admin.User;
import org.objectweb.joram.client.jms.tcp.TopicTcpConnectionFactory;


public class ServerAdmin {

	public static void main(String[] args) throws Exception {
		
		    System.setProperty("java.naming.factory.initial","fr.dyade.aaa.jndi2.client.NamingContextFactory");
	        System.setProperty("java.naming.factory.host","localhost");
	        System.setProperty("java.naming.factory.port","16400");
	        
	        AdminModule.connect("localhost",16010,"root","root",60);
	        User anonimo = User.create("anonymous","anonymous");
	        String MyTopic = new String("MyTopic");
	        
	         org.objectweb.joram.client.jms.Topic topic =  (org.objectweb.joram.client.jms.Topic) org.objectweb.joram.client.jms.Topic.create(MyTopic);     
	        TopicConnectionFactory tcf = TopicTcpConnectionFactory.create("localhost",16010);
	        
	        topic.setFreeWriting();
	        topic.setFreeReading();
	        
	        Context jndiCtx = new InitialContext();
	        
	        jndiCtx.bind("TopicConnectionFactory", tcf);
	        jndiCtx.bind("MyTopic", topic);

	        System.out.println("All Done.");
	        
	        System.exit(0);
	}

}
