package jmsweb2;

import javax.jms.*;
import javax.naming.*;

import javax.jms.JMSException;
import javax.jms.MessageListener;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicSession;
import javax.jms.TopicSubscriber;
import javax.naming.InitialContext;
import javax.naming.NamingException;


public class Subscriber {
	

	public void start() {
	
        
        System.setProperty("java.naming.factory.initial","fr.dyade.aaa.jndi2.client.NamingContextFactory");
        System.setProperty("javax.naming.factory.host","localhost");
        System.setProperty("javax.naming.factory.port","16400");
        
        String login = Publisher.login;
        String MySelecta = "login <> '" + login + "'";
        
		InitialContext initCtx;
		
		try {
			
			initCtx = new InitialContext();
			
            // lookup della TopicConnectionFactory
			
			TopicConnectionFactory topicCF = (TopicConnectionFactory) initCtx.lookup("TopicConnectionFactory");
			
	        //lookup del Topic
			
			Topic topic = (Topic) initCtx.lookup("MyTopic");
			
			initCtx.close();
			
			TopicConnection topicConnection = topicCF.createTopicConnection();
			
			//Creo la Sessione
			
			TopicSession topicSession = topicConnection.createTopicSession(false,TopicSession.AUTO_ACKNOWLEDGE);
			
			//Creo il Topic Subscriber
			
			TopicSubscriber topicSubscriber = topicSession.createDurableSubscriber(topic, login, MySelecta, true);
			
			//Creo il Message Listener
			
			MessageListener listener = new MyMessageListener();
			
			//Associo il Message Listener al Subscriber
			
			topicSubscriber.setMessageListener(listener);
			
			//faccio partire la connessione
			
			topicConnection.start();
			
		} catch (NamingException e) {
			e.printStackTrace();
		} catch (JMSException e) {
			e.printStackTrace();
		}
			
				
		}
		
		
	}

